Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision 01b6bd08f11fd74e3dcb6881617f495881dee060)
+++ sansview/perspectives/fitting/basepage.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -21,6 +21,6 @@
 
 _BOX_WIDTH = 76
-_QMIN_DEFAULT = 0.001
-_QMAX_DEFAULT = 0.13
+_QMIN_DEFAULT = 0.0005
+_QMAX_DEFAULT = 0.5
 _NPTS_DEFAULT = 50
 #Control panel width 
@@ -33,5 +33,7 @@
     FONT_VARIANT = 1
     ON_MAC = True
-    
+
+
+
 class BasicPage(ScrolledPanel, PanelBase):
     """
@@ -39,9 +41,9 @@
     """
      ## Internal name for the AUI manager
-    window_name = "Basic Page"
+    window_name = "Fit Page"
     ## Title to appear on top of the window
-    window_caption = "Basic page "
-    
-    def __init__(self, parent, page_info, **kwargs):
+    window_caption = "Fit Page "
+    
+    def __init__(self, parent,color='blue', **kwargs):
         """
         """
@@ -51,5 +53,6 @@
         #Set window's font size 
         self.SetWindowVariant(variant=FONT_VARIANT)
-       
+      
+        self.SetBackgroundColour(color)
         ## parent of the page
         self.parent = parent
@@ -62,8 +65,9 @@
         self.data = None
         self.mask = None
+        self.id = None
         ## Q range
-        self.qmax_x = None
-        self.qmin_x = None
-        self.num_points= _NPTS_DEFAULT
+        self.qmax_x = _QMAX_DEFAULT
+        self.qmin_x = _QMIN_DEFAULT
+        self.npts_x = _NPTS_DEFAULT
         ## total number of point: float
         self.npts = None
@@ -86,6 +90,6 @@
         self.state = PageState(parent=parent)
         ## dictionary containing list of models
-        self.model_list_box = None
-        self.set_page_info(page_info=page_info)
+        self.model_list_box = {}
+       
         ## Data member to store the dispersion object created
         self._disp_obj_dict = {}
@@ -136,19 +140,5 @@
         ## Create context menu for page
         self.popUpMenu = wx.Menu()
-        #id = wx.NewId()
-        #self._undo = wx.MenuItem(self.popUpMenu,id, "Undo",
-        #"cancel the previous action")
-        #self.popUpMenu.AppendItem(self._undo)
-        #self._undo.Enable(False)
-        #wx.EVT_MENU(self, id, self.onUndo)
-        
-        #id = wx.NewId()
-        #self._redo = wx.MenuItem(self.popUpMenu,id,"Redo",
-        #" Restore the previous action")
-        #self.popUpMenu.AppendItem(self._redo)
-        #self._redo.Enable(False)
-        #wx.EVT_MENU(self, id, self.onRedo)       
-        #self.popUpMenu.AppendSeparator()
-        #if sys.platform.count("win32")>0:        
+    
         id = wx.NewId()
         self._keep = wx.MenuItem(self.popUpMenu,id,"BookMark",
@@ -174,4 +164,6 @@
         ## layout
         self.set_layout()
+        
+    
         
     def on_set_focus(self, event):
@@ -305,5 +297,4 @@
         Cancel the previous action
         """
-        #print "enable undo"
         event = PreviousStateEvent(page = self)
         wx.PostEvent(self.parent, event)
@@ -313,5 +304,4 @@
         Restore the previous action cancelled 
         """
-        #print "enable redo"
         event = NextStateEvent(page= self)
         wx.PostEvent(self.parent, event)
@@ -394,4 +384,5 @@
         self.model_list_box = dict
         self.state.model_list_box = self.model_list_box
+        self.initialize_combox()
         
     def initialize_combox(self): 
@@ -1254,7 +1245,7 @@
         Reset the plotting range to a given state
         """
-        if self.check_invalid_panel():
-            return
-        self.qmin.SetValue(str(state.qmin))
+        # if self.check_invalid_panel():
+        #    return
+        self.qmin_tctrl.SetValue(str(state.qmin))
         self.qmax.SetValue(str(state.qmax)) 
 
@@ -1281,6 +1272,5 @@
         self.state.qmin = self.qmin_x
         self.state.qmax = self.qmax_x 
-        if self.npts != None:
-            self.state.npts = self.num_points
+        self.state.npts = self.npts_x
             
     def _onparamEnter_helper(self):
@@ -1312,6 +1302,6 @@
             # If qmin and qmax have been modified, update qmin and qmax and 
             # set the is_modified flag to True
-            if self._validate_qrange(self.qmin, self.qmax):
-                tempmin = float(self.qmin.GetValue())
+            if self._validate_qrange(self.qmin_tcrl, self.qmax):
+                tempmin = float(self.qmin_tcrl.GetValue())
                 if tempmin != self.qmin_x:
                     self.qmin_x = tempmin
@@ -1367,7 +1357,7 @@
             # If qmin and qmax have been modified, update qmin and qmax and 
             # set the is_modified flag to True
-            self.fitrange = self._validate_qrange(self.qmin, self.qmax)
+            self.fitrange = self._validate_qrange(self.qmin_tcrl, self.qmax)
             if self.fitrange:
-                tempmin = float(self.qmin.GetValue())
+                tempmin = float(self.qmin_tcrl.GetValue())
                 if tempmin != self.qmin_x:
                     self.qmin_x = tempmin
@@ -1385,10 +1375,13 @@
                         flag = self.update_pinhole_smear()
                     else:
-                        self._manager.set_smearer_nodraw(smearer=temp_smearer,
+                        self._manager.set_smearer(smearer=temp_smearer,
+                                                  id=self.id,
                                                      qmin=float(self.qmin_x),
-                                                      qmax=float(self.qmax_x))
+                                                      qmax=float(self.qmax_x),
+                                                      draw=False)
                 elif not self._is_2D():
                     self._manager.set_smearer(smearer=temp_smearer,
                                               qmin=float(self.qmin_x),
+                                              id=self.id, 
                                                  qmax= float(self.qmax_x))
                     index_data = ((self.qmin_x <= self.data.x)&\
@@ -1646,6 +1639,6 @@
         to build a call to the fitting perspective manager.
         """
-        if self.check_invalid_panel():
-            return
+        #if self.check_invalid_panel():
+        #    return
         if self.model !=None:
             temp_smear=None
@@ -1653,5 +1646,4 @@
                 if not self.disable_smearer.GetValue():
                     temp_smear= self.current_smearer
-            
             self._manager.draw_model(self.model, 
                                     data=self.data,
@@ -1659,5 +1651,6 @@
                                     qmin=float(self.qmin_x), 
                                     qmax=float(self.qmax_x),
-                                    qstep= float(self.num_points),
+                                    qstep= float(self.npts_x),
+                                    id=self.id,
                                     enable2D=self.enable2D)
         
@@ -1843,7 +1836,7 @@
         Show combox box associate with type of model selected
         """
-        if self.check_invalid_panel():
-            self.shape_rbutton.SetValue(True)
-            return
+        #if self.check_invalid_panel():
+        #    self.shape_rbutton.SetValue(True)
+        #    return
 
         self._show_combox_helper()
@@ -1871,6 +1864,61 @@
                 combobox.Append(name,models)
         return 0
-
+    
     def _onQrangeEnter(self, event):
+        """
+        Check validity of value enter in the Q range field
+        
+        """
+        tcrtl = event.GetEventObject()
+        #Clear msg if previously shown.
+        msg = ""
+        wx.PostEvent(self.parent, StatusEvent(status=msg))
+        # Flag to register when a parameter has changed.
+        is_modified = False
+        if tcrtl.GetValue().lstrip().rstrip() != "":
+            try:
+                value = float(tcrtl.GetValue())
+                tcrtl.SetBackgroundColour(wx.WHITE)
+                # If qmin and qmax have been modified, update qmin and qmax
+                if self._validate_qrange(self.qmin_tcrl, self.qmax):
+                    tempmin = float(self.qmin_tcrl.GetValue())
+                    if tempmin != self.qmin_x:
+                        self.qmin_x = tempmin
+                    tempmax = float(self.qmax.GetValue())
+                    if tempmax != self.qmax_x:
+                        self.qmax_x = tempmax
+                else:
+                    tcrtl.SetBackgroundColour("pink")
+                    msg = "Model Error:wrong value entered : %s" % sys.exc_value
+                    wx.PostEvent(self.parent, StatusEvent(status=msg))
+                    return 
+            except:
+                tcrtl.SetBackgroundColour("pink")
+                msg = "Model Error:wrong value entered : %s" % sys.exc_value
+                wx.PostEvent(self.parent, StatusEvent(status=msg))
+                return 
+            #Check if # of points for theory model are valid(>0).
+            if self.npts != None:
+                if check_float(self.npts):
+                    temp_npts = float(self.npts.GetValue())
+                    if temp_npts !=  self.num_points:
+                        self.num_points = temp_npts
+                        is_modified = True
+                else:
+                    msg = "Cannot Plot :No npts in that Qrange!!!  "
+                    wx.PostEvent(self.parent, StatusEvent(status=msg))
+        else:
+           tcrtl.SetBackgroundColour("pink")
+           msg = "Model Error:wrong value entered!!!"
+           wx.PostEvent(self.parent, StatusEvent(status=msg))
+        #self._undo.Enable(True)
+        self.save_current_state()
+        event = PageInfoEvent(page=self)
+        wx.PostEvent(self.parent, event)
+        self.state_change = False
+        #Draw the model for a different range
+        self._draw_model()
+                   
+    def _theory_qrange_enter(self, event):
         """
         Check validity of value enter in the Q range field
@@ -1889,25 +1937,25 @@
 
                 # If qmin and qmax have been modified, update qmin and qmax
-                if self._validate_qrange( self.qmin, self.qmax):
-                    tempmin = float(self.qmin.GetValue())
-                    if tempmin != self.qmin_x:
-                        self.qmin_x = tempmin
-                    tempmax = float(self.qmax.GetValue())
+                if self._validate_qrange(self.theory_qmin, self.theory_qmax):
+                    tempmin = float(self.theory_qmin.GetValue())
+                    if tempmin != self.theory_qmin_x:
+                        self.theory_qmin_x = tempmin
+                    tempmax = float(self.theory_qmax.GetValue())
                     if tempmax != self.qmax_x:
-                        self.qmax_x = tempmax
+                        self.theory_qmax_x = tempmax
                 else:
                     tcrtl.SetBackgroundColour("pink")
                     msg= "Model Error:wrong value entered : %s"% sys.exc_value
-                    wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))
+                    wx.PostEvent(self._manager.parent, StatusEvent(status = msg ))
                     return  
             except:
                 tcrtl.SetBackgroundColour("pink")
                 msg= "Model Error:wrong value entered : %s"% sys.exc_value
-                wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))
+                wx.PostEvent(self._manager.parent, StatusEvent(status = msg ))
                 return 
             #Check if # of points for theory model are valid(>0).
-            if self.npts != None:
-                if check_float(self.npts):
-                    temp_npts = float(self.npts.GetValue())
+            if self.theory_npts != None:
+                if check_float(self.theory_npts):
+                    temp_npts = float(self.theory_npts.GetValue())
                     if temp_npts !=  self.num_points:
                         self.num_points = temp_npts
@@ -1918,5 +1966,5 @@
         else:
            tcrtl.SetBackgroundColour("pink")
-           msg= "Model Error:wrong value entered!!!"
+           msg = "Model Error:wrong value entered!!!"
            wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
         #self._undo.Enable(True)
@@ -2068,5 +2116,5 @@
                             self.data.qy_data * self.data.qy_data )
         #get unmasked index
-        index_data = (float(self.qmin.GetValue()) <= radius) & \
+        index_data = (float(self.qmin_tcrl.GetValue()) <= radius) & \
                         (radius <= float(self.qmax.GetValue()))
         index_data = (index_data) & (self.data.mask) 
@@ -2075,6 +2123,6 @@
         if len(index_data[index_data]) < 10:
             # change the color pink.
-            self.qmin.SetBackgroundColour("pink")
-            self.qmin.Refresh()
+            self.qmin_tcrl.SetBackgroundColour("pink")
+            self.qmin_tcrl.Refresh()
             self.qmax.SetBackgroundColour("pink")
             self.qmax.Refresh()
@@ -2188,6 +2236,6 @@
         Redraw the model with the default dispersity (Gaussian)
         """
-        if self.check_invalid_panel():
-            return 
+        #if self.check_invalid_panel():
+        #    return 
         ## On selction if no model exists.
         if self.model ==None:
@@ -2412,79 +2460,5 @@
         event = PageInfoEvent(page = self)
         wx.PostEvent(self.parent, event)
-        
-    def _set_range_sizer(self, title, box_sizer=None, object1=None,object=None):
-        """
-        Fill the Q range sizer
-        """
-        #2D data? default
-        is_2Ddata = False
-        
-        #check if it is 2D data
-        if self.data.__class__.__name__ == 'Data2D':
-            is_2Ddata = True
-            
-        self.sizer5.Clear(True)
-        #--------------------------------------------------------------
-        if box_sizer == None:
-            box_description= wx.StaticBox(self, -1,str(title))
-            boxsizer1 = wx.StaticBoxSizer(box_description, wx.VERTICAL)
-        else:
-            #for MAC
-            boxsizer1 = box_sizer
-
-        self.qmin    = self.ModelTextCtrl(self, -1,size=(_BOX_WIDTH,20),style=wx.TE_PROCESS_ENTER,
-                                            text_enter_callback = self._onQrangeEnter)
-        self.qmin.SetValue(str(self.qmin_x))
-        self.qmin.SetToolTipString("Minimun value of Q in linear scale.")
-     
-        self.qmax    = self.ModelTextCtrl(self, -1,size=(_BOX_WIDTH,20),style=wx.TE_PROCESS_ENTER,
-                                            text_enter_callback = self._onQrangeEnter)
-        self.qmax.SetValue(str(self.qmax_x))
-        self.qmax.SetToolTipString("Maximum value of Q in linear scale.")
-        
-        id = wx.NewId()
-        self.reset_qrange =wx.Button(self,id,'Reset',size=(77,20))
-      
-        self.reset_qrange.Bind(wx.EVT_BUTTON, self.on_reset_clicked,id=id)
-        self.reset_qrange.SetToolTipString("Reset Q range to the default values")
-     
-        sizer_horizontal=wx.BoxSizer(wx.HORIZONTAL)
-        sizer= wx.GridSizer(2, 4,2, 6)
-
-        self.btEditMask = wx.Button(self,wx.NewId(),'Editor', size=(88,23))
-        self.btEditMask.Bind(wx.EVT_BUTTON, self._onMask,id= self.btEditMask.GetId())
-        self.btEditMask.SetToolTipString("Edit Mask.")
-        self.EditMask_title = wx.StaticText(self, -1, ' Masking(2D)')
-
-        sizer.Add(wx.StaticText(self, -1, '    Q range'))     
-        sizer.Add(wx.StaticText(self, -1, ' Min[1/A]'))
-        sizer.Add(wx.StaticText(self, -1, ' Max[1/A]'))
-        sizer.Add(self.EditMask_title)
-        sizer.Add(self.reset_qrange)   
-        
-        sizer.Add(self.qmin)
-        sizer.Add(self.qmax)
-        sizer.Add(self.btEditMask)
-       
-        if object1!=None:
-            
-            boxsizer1.Add(object1) 
-            boxsizer1.Add((10,10))
-        boxsizer1.Add(sizer)
-        if object!=None:
-            boxsizer1.Add((10,15))
-            boxsizer1.Add(object)
-        if is_2Ddata:
-            self.btEditMask.Enable()  
-            self.EditMask_title.Enable() 
-        else:
-            self.btEditMask.Disable()  
-            self.EditMask_title.Disable()
-        ## save state
-        self.save_current_state()
-        #----------------------------------------------------------------
-        self.sizer5.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
-        self.sizer5.Layout()
-
+   
     def _lay_out(self):
         """
@@ -2511,6 +2485,6 @@
         """
         flag = True
-        if self.check_invalid_panel():
-            return
+        #if self.check_invalid_panel():
+        #    return
         ##For 3 different cases: Data2D, Data1D, and theory
         if self.data.__class__.__name__ == "Data2D":
@@ -2552,5 +2526,5 @@
         else:
             # set relative text ctrs.
-            self.qmin.SetValue(str(self.qmin_x))
+            self.qmin_tcrl.SetValue(str(self.qmin_x))
             self.qmax.SetValue(str(self.qmax_x))
             self.set_npts2fit()
@@ -2569,5 +2543,4 @@
         self._draw_model()
 
-
     def on_model_help_clicked(self,event):
         """
@@ -2575,9 +2548,5 @@
         """
         from help_panel import  HelpWindow
-        import sans.models as models 
-        
-        # Get models help model_function path
-        path = models.get_data_path(media='media')
-        model_path = os.path.join(path,"model_functions.html")
+        
         if self.model == None:
             name = 'FuncHelp'
@@ -2585,5 +2554,5 @@
             name = self.model.origin_name
 
-        frame = HelpWindow(None, -1,  pageToOpen=model_path)    
+        frame = HelpWindow(None, -1,  pageToOpen="media/model_functions.html")    
         frame.Show(True)
         if frame.rhelp.HasAnchor(name):
@@ -2592,5 +2561,4 @@
            msg= "Model does not contains an available description "
            msg +="Please try searching in the Help window"
-           wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))      
-                    
+           wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))                    
                 
Index: sansview/perspectives/fitting/fit_thread.py
===================================================================
--- sansview/perspectives/fitting/fit_thread.py	(revision 5062bbf9abf800e4b5ffab0375da1c4a03967672)
+++ sansview/perspectives/fitting/fit_thread.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -10,5 +10,4 @@
                    handler,
                   pars=None,
-                 cpage=None,
                  completefn = None,
                  updatefn   = None,
@@ -23,5 +22,4 @@
         self.handler = handler
         self.fitter = fn
-        self.cpage= cpage
         self.pars = pars
         self.starttime = 0
@@ -49,6 +47,5 @@
             self.updatefn()
             self.complete(result= result,
-                          pars = self.pars,
-                          cpage= self.cpage)
+                          pars = self.pars)
            
         except KeyboardInterrupt, msg:
